﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using Microsoft.Surface.Presentation.Controls;

namespace LongClickButtonTest
{
    [TemplatePart(Name = LongButton.ImageButtonName, Type = typeof(Image))]
    public class LongButton : Control
    {
        internal const string ImageButtonName = "ImageButton";
        internal Image ImageButton;

        private int _StartTick = 0;

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();

            ImageButton = this.GetTemplateChild(LongButton.ImageButtonName) as Image;
        }

        public LongButton()
        {
            this.DefaultStyleKey = typeof(LongButton);
            this.MouseLeftButtonDown += new System.Windows.Input.MouseButtonEventHandler(LongButton_MouseLeftButtonDown);
            this.MouseLeftButtonUp += new System.Windows.Input.MouseButtonEventHandler(LongButton_MouseLeftButtonUp);
        }

        private void LongButton_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            ImageButton.Source = new BitmapImage(new Uri("/LongClickButtonTest;component/Images/x_btn_default.png", UriKind.Relative));
            CompositionTarget.Rendering -= new EventHandler(CompositionTarget_Rendering);
        }

        private void LongButton_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            _StartTick = Environment.TickCount;
            CompositionTarget.Rendering -= new EventHandler(CompositionTarget_Rendering);
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
            ImageButton.Source = new BitmapImage(new Uri("/LongClickButtonTest;component/Images/x_btn_focus.png", UriKind.Relative));
        }

        private void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            var duration = Environment.TickCount - _StartTick;
            Debug.WriteLine(duration);
            if (duration > 1000)
            {
                Debug.WriteLine("성공");
                CompositionTarget.Rendering -= new EventHandler(CompositionTarget_Rendering);
            }
        }
    }
}